<link rel="import" href="../../polymer/polymer-element.html" />

<dom-module id="app-datos-acceso">
    <template>
        <link rel="stylesheet" href="css/bulma.min.css" />
        <div class="field">
            <label class="label" for="correo">Correo electrónico</label>
            <input
                class="input is-rounded"
                type="email"
                name="correo"
                id="correo"
                value="[[correo]]"
                disabled
            />
            <div class="columns">
                <div class="field column">
                    <label class="label" for="clave1">Contraseña nueva</label>
                    <input
                        class="input is-rounded"
                        type="password"
                        name="clave1"
                        id="clave1"
                        value="{{clave1::input}}"
                        minlength="8"
                        placeholder="********"
                    />
                    <p class="help is-danger is-hidden" id="menos-chars">
                        La contraseña debe tener al menos 8 caracteres
                    </p>
                </div>
                <div class="field column">
                    <label class="label" for="clave2">Repite tu contraseña nueva</label>
                    <input
                        class="input is-rounded"
                        type="password"
                        name="clave2"
                        id="clave2"
                        value="{{clave2::input}}"
                        minlength="8"
                        placeholder="********"
                    />
                    <p class="help is-danger is-hidden" id="no-iguales">
                        Las contraseñas no coinciden
                    </p>
                </div>
            </div>
            <button type="button" class="button is-danger is-outlined" on-click="desactivarCuenta">
                Desactivar cuenta
            </button>
            <button type="button" class="button is-primary" on-click="guardarNuevaContraseña">
                Guardar cambios
            </button>
        </div>

        <div class="modal">
            <div class="modal-background"></div>
            <div class="modal-card">
                <header class="modal-card-head has-background-danger">
                    <p class="modal-card-title has-text-white">¡Acción destructiva!</p>
                    <button class="delete" aria-label="close" on-click="cerrarModal"></button>
                </header>
                <section class="modal-card-body">
                    <p>¿Estás seguro de <strong>desactivar</strong> tu cuenta?</p>
                    <p>Tú y tus artículos ya no estarán disponibles.</p>
                </section>
                <footer class="modal-card-foot" style="justify-content: flex-end;">
                    <button class="button is-pulled-right" on-click="cerrarModal">
                        Cancelar
                    </button>
                    <button class="button is-danger is-pulled-right">Desactivar cuenta</button>
                </footer>
            </div>
        </div>
    </template>

    <script>
        class AppDatosAcceso extends Polymer.Element {
            static get is() {
                return "app-datos-acceso";
            }
            static get properties() {
                return {
                    correo: {
                        type: String,
                        value: "a@a.com",
                    },
                    clave1: {
                        type: String,
                        value: "",
                    },
                    clave2: {
                        type: String,
                        value: "",
                    },
                };
            }
            guardarNuevaContraseña() {
                console.log(this.clave1);
                if (this.clave1.length < 8) {
                    this.shadowRoot.querySelector("#menos-chars").classList.remove("is-hidden");
                    this.shadowRoot
                        .querySelectorAll("input[type=password]")[0]
                        .classList.add("is-danger");
                    return;
                }
                this.shadowRoot.querySelector("#menos-chars").classList.add("is-hidden");

                if (this.clave1 !== this.clave2) {
                    this.shadowRoot.querySelector("#no-iguales").classList.remove("is-hidden");
                    this.shadowRoot.querySelectorAll("input[type=password]").forEach((element) => {
                        element.classList.add("is-danger");
                    });
                } else {
                    this.shadowRoot.querySelector("#no-iguales").classList.add("is-hidden");
                    this.shadowRoot.querySelectorAll("input[type=password]").forEach((element) => {
                        element.classList.remove("is-danger");
                    });
                }
            }

            desactivarCuenta() {
                this.shadowRoot.querySelector(".modal").classList.add("is-active");
            }
            cerrarModal() {
                this.shadowRoot.querySelector(".modal").classList.remove("is-active");
            }
        }

        window.customElements.define(AppDatosAcceso.is, AppDatosAcceso);
    </script>
</dom-module>
